package util.coll;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;

/**
 * Erweiterung {@link ArrayList}
 * um Methoden und Konstruktoren
 * fr die Bequemlichkeit.
 * 
 * @param <E> Typ-Parameter, Element-Typ der Liste
 * @author Heiner K&uuml;cker
 */
@SuppressWarnings( "serial" )
public class XArrayList<E>
extends ArrayList<E>
{
	/**
	 * 
	 */
	public XArrayList()
	{
		super();
	}

	/**
	 * @param initialCapacity
	 */
	public XArrayList(
			final int initialCapacity )
	{
		super( initialCapacity );
	}

	/**
	 * @param coll
	 */
	public XArrayList(
			final Collection<? extends E> coll )
	{
		super( coll );
	}

	/**
	 * @param vararg vararg-Parameter fr Schreib-Erleichterung
	 */
	public XArrayList(
			final E... vararg )
	{
		super(
				Arrays.asList(
						vararg ) );
	}

}
