package util.hlist.immutable;

/**
 * Nachbildung Scala HList
 * (heterogene Liste,
 *  Liste mit unterschiedlichen
 *  Typen je Position, aber trotzdem
 *  typsicher)
 * mit Java-Generics.
 * 
 * @param <T> Type-Parameter, Type des aktuellen Wertes
 * @param <N> Type-Parameter, Type des Nachfolger-Entry
 * @author Heiner K&uuml;cker
 */
public abstract class AbstractHListEntry<T, N extends AbstractHListEntry<?, ?>>
{
	/**
	 * aktueller Wert
	 */
	public final T value;

	/**
	 * Nchstes Entry-Objekt,
	 * realisiert eine einfach
	 * verlinkte Liste.
	 */
	public final N nextEntry;

	/**
	 * Konstruktor.
	 * 
	 * @param value
	 * @param nextEntry
	 */
	protected AbstractHListEntry(
			final T value ,
			final N nextEntry )
	{
		this.value = value;
		this.nextEntry = nextEntry;
	}
	
}
