package util.hlist.mutable;

/**
 * Nichterminales Listen-Element (Kettenglied).
 * 
 * @param <T> Type-Parameter, Type des aktuellen Wertes
 * @param <N> Type-Parameter, Type des Nachfolger-Entry
 * @author Heiner K&uuml;cker
 */
public class MutableHListEntry<T, N extends AbstractMutableHListEntry<?, ?>>
extends AbstractMutableHListEntry<T, N>
{
	/**
	 * Konstruktor.
	 * 
	 * @param nextEntry
	 */
	public MutableHListEntry(
			final N nextEntry )
	{
		super(
				nextEntry );
	}

	/**
	 * Konstruktor.
	 * 
	 * @param value
	 * @param nextEntry
	 */
	public MutableHListEntry(
			final T value ,
			final N nextEntry )
	{
		super(
				value ,
				nextEntry );
	}

	/**
	 * Bequemlichkeitsmethode zum Zugriff
	 * auf das nchste Entry-Objekt.
	 * 
	 * @return nchstes Entry-Objekt
	 */
	public final N next()
	{
		return this.nextEntry;
	}

}
