package util.yield_for.nested;


/**
 * Implementierungsklasse fr eine
 * zweistufige For-Schleife mit 
 * yield-return.
 * <br/>
 * Die Hierarchie der For-Schleifen
 * endet mit dieser Klasse.
 * 
 * @param <I> Type-Parameter, Typ der Laufvariable der ersten Stufe, traditionsgemss I genannt
 * @param <J> Type-Parameter, Typ der Laufvariable der zweiten Stufe, traditionsgemss J genannt
 * @param <R> Type-Parameter, Typ der Return-Wertes des yield-return
 * @author Heiner K&uuml;cker
 */
abstract public class FinalYieldFor2<I, J, R>
extends NestedOrFinalYieldFor2<I, J, R>
{
	/**
	 * Konstruktor
	 */
	protected FinalYieldFor2()
	{
		super();
	}

	/**
	 * @see NestedOrFinalYieldFor2#outerIs
	 */
	@Override
	final protected boolean outerIs()
	{
		return is(
				this.currentLoopValueLevel2 );
	}

	/**
	 * @see NestedOrFinalYieldFor2#outerSkip
	 */
	@Override
	final protected void outerSkip()
	{
		this.currentLoopValueLevel2 =
				this.skip(
						this.currentLoopValueLevel2 );
	}
}
