package util.yield_for.nested;


/**
 * Implementierungsklasse fr eine
 * dreistufige For-Schleife mit 
 * yield-return.
 * <br/>
 * Die Hierarchie der For-Schleifen
 * endet mit dieser Klasse.
 * 
 * @param <I> Type-Parameter, Typ der Laufvariable der ersten Stufe, traditionsgemss I genannt
 * @param <J> Type-Parameter, Typ der Laufvariable der zweiten Stufe, traditionsgemss J genannt
 * @param <K> Type-Parameter, Typ der Laufvariable der dritten Stufe, traditionsgemss K genannt
 * @param <R> Type-Parameter, Typ der Return-Wertes des yield-return
 * @author Heiner K&uuml;cker
 */
abstract public class FinalYieldFor3<I, J, K, R>
extends NestedOrFinalYieldFor3<I, J, K, R>
{
	/**
	 * Konstruktor.
	 */
	protected FinalYieldFor3()
	{
		super();
	}

	/**
	 * @see NestedOrFinalYieldFor3#outerIs
	 */
	@Override
	final protected boolean outerIs()
	{
		return is(
				this.currentLoopValueLevel3 );
	}

	/**
	 * @see NestedOrFinalYieldFor3#outerSkip
	 */
	@Override
	final protected void outerSkip()
	{
		this.currentLoopValueLevel3 =
				this.skip(
						this.currentLoopValueLevel3 );
	}

}
