package util.yield_for.nested;


/**
 * Implementierungsklasse fr eine
 * vierstufige For-Schleife mit 
 * yield-return.
 * <br/>
 * Die Hierarchie der For-Schleifen
 * endet mit dieser Klasse.
 * 
 * @param <I> Type-Parameter, Typ der Laufvariable der ersten Stufe, traditionsgemss I genannt
 * @param <J> Type-Parameter, Typ der Laufvariable der zweiten Stufe, traditionsgemss J genannt
 * @param <K> Type-Parameter, Typ der Laufvariable der dritten Stufe, traditionsgemss K genannt
 * @param <L> Type-Parameter, Typ der Laufvariable der vierten Stufe, traditionsgemss L genannt
 * @param <R> Type-Parameter, Typ der Return-Wertes des yield-return
 * @author Heiner K&uuml;cker
 */
abstract public class FinalYieldFor4<I, J, K, L, R>
extends NestedOrFinalYieldFor4<I, J, K, L, R>
{
	/**
	 * Konstruktor.
	 */
	protected FinalYieldFor4()
	{
		super();
	}

	/**
	 * @see NestedOrFinalYieldFor4#outerIs
	 */
	@Override
	final protected boolean outerIs()
	{
		return is(
				this.currentLoopValueLevel4 );
	}

	/**
	 * @see NestedOrFinalYieldFor4#outerSkip
	 */
	@Override
	final protected void outerSkip()
	{
		this.currentLoopValueLevel4 =
				this.skip(
						this.currentLoopValueLevel4 );
	}

}
