package util.hlist.immutable;

import junit.framework.Assert;

import org.junit.Test;

/**
 * Test fr HList (heterogene Liste, Liste mit unterschiedlichem Datentyp je Position).
 * 
 * @author Heiner K&uuml;cker
 */
public class JavaHListTest
{
	@Test
    @SuppressWarnings("boxing")
	public final void testGetIndex0_FromListSize1()
	{
		final TerminalHListEntry<Integer> integerTerminalEntry =
				new TerminalHListEntry<Integer>(
				        0 );

		Assert.assertEquals(
				//expected
				0 ,
				//actual
				JavaHList.get0(
						integerTerminalEntry ).intValue() );
	}

	@Test
    @SuppressWarnings("boxing")
	public final void testGetIndex0_FromListSize2()
	{
		final HListEntry<Integer, TerminalHListEntry<Object>> objectIntegerList =
				new HListEntry<Integer, TerminalHListEntry<Object>>(
						1 ,
						new TerminalHListEntry<Object>(
								new Object() ) );

		Assert.assertEquals(
				//expected
				1 ,
				//actual
				JavaHList.get0(
						objectIntegerList ).intValue() );

	}

	@Test
    @SuppressWarnings("boxing")
	public final void testGetIndex0_FromListSize3()
	{
		final HListEntry<Integer, HListEntry<Object, TerminalHListEntry<Object>>> objectObjectIntegerList =
				new HListEntry<Integer, HListEntry<Object, TerminalHListEntry<Object>>>(
						1 ,
						new HListEntry<Object, TerminalHListEntry<Object>>(
								new Object() ,
								new TerminalHListEntry<Object>(
										new Object() ) ) );

		Assert.assertEquals(
				//expected
				1 ,
				//actual
				JavaHList.get0(
						objectObjectIntegerList ).intValue() );

	}

	@Test
    @SuppressWarnings("boxing")
	public final void testGetIndex1_FromListSize2()
	{
		final HListEntry<Object, TerminalHListEntry<Integer>> objectIntegerList =
				new HListEntry<Object, TerminalHListEntry<Integer>>(
						new Object() ,
						new TerminalHListEntry<Integer>(
								 1 ) );

		Assert.assertEquals(
				//expected
				1 ,
				//actual
				JavaHList.get1(
						objectIntegerList ).intValue() );
	}

	@Test
    @SuppressWarnings("boxing")
	public final void testGetIndex1_FromListSize3()
	{
		final HListEntry<Object, HListEntry<Integer, TerminalHListEntry<Object>>> objectIntegerObjectList =
				new HListEntry<Object, HListEntry<Integer, TerminalHListEntry<Object>>>(
						new Object() ,
						new HListEntry<Integer, TerminalHListEntry<Object>>(
								1 ,
								new TerminalHListEntry<Object>(
										new Object() ) ) );

		Assert.assertEquals(
				//expected
				1 ,
				//actual
				JavaHList.get1(
						objectIntegerObjectList ).intValue() );
	}

	@Test
    @SuppressWarnings("boxing")
	public final void testGetIndex2_FromListSize3()
	{
		final HListEntry<Object, HListEntry<Object, TerminalHListEntry<Integer>>> objectObjectIntegerList =
				new HListEntry<Object, HListEntry<Object, TerminalHListEntry<Integer>>>(
						new Object() ,
						new HListEntry<Object, TerminalHListEntry<Integer>>(
								new Object() ,
								new TerminalHListEntry<Integer>(
										 2 ) ) );

		Assert.assertEquals(
				//expected
				2 ,
				//actual
				JavaHList.get2(
						objectObjectIntegerList ).intValue() );
	}

	@Test
    @SuppressWarnings("boxing")
	public final void testGetIndex2_FromListSize4()
	{
		final HListEntry<Object, HListEntry<Object, HListEntry<Integer, TerminalHListEntry<Object>>>> objectObjectIntegerObjectList =
				new HListEntry<Object, HListEntry<Object, HListEntry<Integer, TerminalHListEntry<Object>>>>(
						new Object() ,
						new HListEntry<Object, HListEntry<Integer, TerminalHListEntry<Object>>>(
								new Object() ,
								new HListEntry<Integer, TerminalHListEntry<Object>>(
										2 ,
										new TerminalHListEntry<Object>(
												new Object() ) ) ) );

		Assert.assertEquals(
				//expected
				2 ,
				//actual
				JavaHList.get2(
						objectObjectIntegerObjectList ).intValue() );
	}

	@Test
    @SuppressWarnings("boxing")
	public final void testGetIndex3_FromListSize4()
	{
		final HListEntry<Object, HListEntry<Object, HListEntry<Object, TerminalHListEntry<Integer>>>> objectObjectObjectIntegerList =
				new HListEntry<Object, HListEntry<Object, HListEntry<Object, TerminalHListEntry<Integer>>>>(
						new Object() ,
						new HListEntry<Object, HListEntry<Object, TerminalHListEntry<Integer>>>(
								new Object() ,
								new HListEntry<Object, TerminalHListEntry<Integer>>(
										new Object() ,
										new TerminalHListEntry<Integer>(
												3 ) ) ) );

		Assert.assertEquals(
				//expected
				3 ,
				//actual
				JavaHList.get3(
						objectObjectObjectIntegerList ).intValue() );
	}

	@Test
    @SuppressWarnings("boxing")
	public final void testGetIndex3_FromListSize5()
	{
		final HListEntry<Object, HListEntry<Object, HListEntry<Object, HListEntry<Integer, TerminalHListEntry<Object>>>>> objectObjectObjectIntegerObjectList =
				new HListEntry<Object, HListEntry<Object, HListEntry<Object, HListEntry<Integer, TerminalHListEntry<Object>>>>>(
						new Object() ,
						new HListEntry<Object, HListEntry<Object, HListEntry<Integer, TerminalHListEntry<Object>>>>(
								new Object() ,
								new HListEntry<Object, HListEntry<Integer, TerminalHListEntry<Object>>>(
										new Object() ,
										new HListEntry<Integer, TerminalHListEntry<Object>>(
												3 ,
												new TerminalHListEntry<Object>(
														new Object() ) ) ) ) );

		Assert.assertEquals(
				//expected
				3 ,
				//actual
				JavaHList.get3(
						objectObjectObjectIntegerObjectList ).intValue() );
	}

	@Test
    @SuppressWarnings("boxing")
	public final void testGetIndex4_FromListSize5()
	{
		final HListEntry<Object, HListEntry<Object, HListEntry<Object, HListEntry<Object, TerminalHListEntry<Integer>>>>> objectObjectObjectObjectIntegerList =
				new HListEntry<Object, HListEntry<Object, HListEntry<Object, HListEntry<Object, TerminalHListEntry<Integer>>>>>(
						new Object() ,
						new HListEntry<Object, HListEntry<Object, HListEntry<Object, TerminalHListEntry<Integer>>>>(
								new Object() ,
								new HListEntry<Object, HListEntry<Object, TerminalHListEntry<Integer>>>(
										new Object() ,
										new HListEntry<Object, TerminalHListEntry<Integer>>(
												new Object() ,
												new TerminalHListEntry<Integer>(
														4 ) ) ) ) );

		Assert.assertEquals(
				//expected
				4 ,
				//actual
				JavaHList.get4(
						objectObjectObjectObjectIntegerList ).intValue() );
	}

	@Test
    @SuppressWarnings("boxing")
	public final void testGetIndex4_FromListSize6()
	{
		final HListEntry<Object, HListEntry<Object, HListEntry<Object, HListEntry<Object, HListEntry<Integer, TerminalHListEntry<Object>>>>>> objectObjectObjectObjectIntegerObjectList =
				new HListEntry<Object, HListEntry<Object, HListEntry<Object, HListEntry<Object, HListEntry<Integer, TerminalHListEntry<Object>>>>>>(
						new Object() ,
						new HListEntry<Object, HListEntry<Object, HListEntry<Object, HListEntry<Integer, TerminalHListEntry<Object>>>>>(
								new Object() ,
								new HListEntry<Object, HListEntry<Object, HListEntry<Integer, TerminalHListEntry<Object>>>>(
										new Object() ,
										new HListEntry<Object, HListEntry<Integer, TerminalHListEntry<Object>>>(
												new Object() ,
												new HListEntry<Integer, TerminalHListEntry<Object>>(
														4 ,
														new TerminalHListEntry<Object>(
																new Object() ) ) ) ) ) );

		Assert.assertEquals(
				//expected
				4 ,
				//actual
				JavaHList.get4(
						objectObjectObjectObjectIntegerObjectList ).intValue() );
	}

}
