package util.iterator.recursiv;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

import junit.framework.Assert;

import org.junit.Test;

/**
 * JUnit4-Testcase fr die Klasse
 * {@link RecursivIterator}.
 * 
 * @author Heiner K&uuml;cker
 */
public class RecursivIteratorTest
{
	/**
	 * Test method for {@link RecursivIterator}.
	 */
	@Test
    @SuppressWarnings("boxing")
	public final void testTwoDim()
	{
		final List<Integer> list0 =
				Arrays.asList(
						0 ,
						1 ,
						2 );

		final RecursivOrTerminalIterator<Integer> recursivIteratorTwoDim =
				new RecursivIterator<Integer>(
						new TerminalIterator<Integer>( list0.iterator() ) ,
						new TerminalIterator<Integer>( list0.iterator() ) ,
						new TerminalIterator<Integer>( list0.iterator() ) );

		final List<Integer> expectedList =
				new ArrayList<Integer>();

		for ( int i = 0 ; i < 3 ; i++ )
		{
			for ( int j = 0 ; j < 3 ; j++ )
			{
				expectedList.add( j );
			}
		}

		final Iterator<Integer> expectedIterator =
				expectedList.iterator();

		int counter = 0;

		while ( recursivIteratorTwoDim.hasNext() )
		{
			final int actual =
					recursivIteratorTwoDim.next();

			System.out.println( actual );

			Assert.assertEquals(
					expectedIterator.next().intValue() ,
					actual );

			counter++;
		}

		Assert.assertEquals(
				//expected
				3 * 3 ,
				//actual
				counter );
	}

	/**
	 * Test method for {@link RecursivIterator}.
	 */
	@Test
    @SuppressWarnings("boxing")
	public final void testThreeDim()
	{
		final List<Integer> list0 =
				Arrays.asList(
						0 ,
						1 ,
						2 );

		final RecursivOrTerminalIterator<Integer> recursivIteratorThreeDim =
				new RecursivIterator<Integer>(
						new RecursivIterator<Integer>(
								new TerminalIterator<Integer>( list0.iterator() ) ,
								new TerminalIterator<Integer>( list0.iterator() ) ,
								new TerminalIterator<Integer>( list0.iterator() ) ) ,
						new RecursivIterator<Integer>(
								new TerminalIterator<Integer>( list0.iterator() ) ,
								new TerminalIterator<Integer>( list0.iterator() ) ,
								new TerminalIterator<Integer>( list0.iterator() ) ) ,
						new RecursivIterator<Integer>(
								new TerminalIterator<Integer>( list0.iterator() ) ,
								new TerminalIterator<Integer>( list0.iterator() ) ,
								new TerminalIterator<Integer>( list0.iterator() ) ) );

		final List<Integer> expectedList =
				new ArrayList<Integer>();
		
		for ( int i = 0 ; i < 3 ; i++ )
		{
			for ( int j = 0 ; j < 3 ; j++ )
			{
				for ( int k = 0 ; k < 3 ; k++ )
				{
					expectedList.add( k );
				}
			}
		}

		final Iterator<Integer> expectedIterator =
				expectedList.iterator();

		int counter = 0;

		while ( recursivIteratorThreeDim.hasNext() )
		{
			final int actual =
					recursivIteratorThreeDim.next();

			System.out.println( actual );

			Assert.assertEquals(
					expectedIterator.next().intValue() ,
					actual );

			counter++;
		}

		Assert.assertEquals(
				//expected
				3 * 3 * 3 ,
				//actual
				counter );
	}

}
