package util.yield_for.nested;

import java.util.ArrayList;
import java.util.Arrays;

import junit.framework.Assert;

import org.junit.Test;

import util.yield_for.nested.FinalYieldFor1;

/**
 * JUnit4-Testcase fr die Klasse
 * {@link FinalYieldFor1}.
 * 
 * @author Heiner K&uuml;cker
 */
public class FinalYieldFor1Test
{
	/**
	 * Test method for {@link FinalYieldFor1}.
	 */
	@Test
	@SuppressWarnings("boxing")
	public final void test()
	{
		/*
		 * Nachbildung
		 * for ( int i = 0 ; i < 3 ; i++ )
		 *      yield return String.valueOf( i * 10 );
		 */
		final FinalYieldFor1<Integer, String> yieldFor =
				new FinalYieldFor1<Integer, String>()
				{
					@Override
					protected Integer initialValue()
					{
						return 0;
					}

					@Override
					protected boolean is(
							final Integer currentLoopValueLevel1 )
					{
						return currentLoopValueLevel1 < 3;
					}

					@Override
					protected Integer skip(
							final Integer currentLoopValueLevel1 )
					{
						return currentLoopValueLevel1 + 1;
					}

					@Override
					protected String yieldReturn(
							final Integer currentLoopValueLevel1 )
					{
						return String.valueOf(
								currentLoopValueLevel1 * 10 );
					}
				};

		final ArrayList<String> actual = new ArrayList<String>();
		
		while ( yieldFor.hasNext() )
		{
			final String value = yieldFor.next();
			
			actual.add( value );
			
			System.out.println( value );
		}
		
		Assert.assertEquals(
				//expected
				new ArrayList<String>(
						Arrays.asList(
								"0" ,
								"10" ,
								"20" ) ) ,
				actual );
	}

}
