package util.yield_for.nested;

import java.util.ArrayList;
import java.util.Arrays;

import junit.framework.Assert;

import org.junit.Test;

import util.yield_for.nested.FinalYieldFor3;
import util.yield_for.nested.NestedOrFinalYieldFor2;
import util.yield_for.nested.NestedOrFinalYieldFor3;
import util.yield_for.nested.NestedYieldFor1;
import util.yield_for.nested.NestedYieldFor2;

/**
 * JUnit4-Testcase fr die Klasse
 * {@link FinalYieldFor3}.
 * 
 * @author Heiner K&uuml;cker
 */
public class FinalYieldFor3Test
{
	/**
	 * Test method for {@link FinalYieldFor3}.
	 */
	@Test
	@SuppressWarnings("boxing")
	public final void testDigitsDigitsDigits()
	{
		/*
		 * Nachbildung
		 * for ( int i = 0 ; i < 3 ; i++ )
		 *     for ( int j = 0 ; j < 3 ; j++ )
		 *         for ( int k = 0 ; k < 3 ; k++ )
		 *             yield return ( i + "" + j + "" + k );
		 */
		final NestedYieldFor1<Integer, String> yieldFor =
				new NestedYieldFor1<Integer, String>()
				{
					@Override
					protected Integer initialValue()
					{
						return 0;
					}

					@Override
					protected boolean is(
							final Integer currentLoopValueLevel1 )
					{
						return currentLoopValueLevel1 < 3;
					}

					@Override
					protected Integer skip(
							final Integer currentLoopValueLevel1 )
					{
						return currentLoopValueLevel1 + 1;
					}

					@Override
					protected NestedOrFinalYieldFor2<Integer, ?, String> subFor()
					{
						return
								new NestedYieldFor2<Integer, Integer, String>()
								{
									@Override
									protected Integer initialValue()
									{
										return 0;
									}

									@Override
									protected boolean is(
											final Integer currentLoopValueLevel2 )
									{
										return currentLoopValueLevel2 < 3;
									}

									@Override
									protected Integer skip(
											final Integer currentLoopValueLevel2 )
									{
										return currentLoopValueLevel2 + 1;
									}

									@Override
									protected NestedOrFinalYieldFor3<Integer, Integer, ?, String> subFor()
									{
										return
												new FinalYieldFor3<Integer, Integer, Integer, String>()
												{
													@Override
													protected Integer initialValue()
													{
														return 0;
													}

													@Override
													protected boolean is(
															final Integer currentLoopValueLevel2 )
													{
														return currentLoopValueLevel2 < 3;
													}

													@Override
													protected Integer skip(
															final Integer currentLoopValueLevel2 )
													{
														return currentLoopValueLevel2 + 1;
													}

													@Override
													protected String yieldReturn(
															final Integer currentLoopValueLevel1 ,
															final Integer currentLoopValueLevel2 ,
															final Integer currentLoopValueLevel3 )
													{
														return
																currentLoopValueLevel1 + 
																"" + 
																currentLoopValueLevel2 + 
																"" + 
																currentLoopValueLevel3;
													}
												};
									}
								};
					}
				};

		final ArrayList<String> actual = new ArrayList<String>();

		while ( yieldFor.hasNext() )
		{
			final String value = yieldFor.next();

			actual.add( value );

			System.out.println( value );
		}

		Assert.assertEquals(
				//expected
				new ArrayList<String>(
						Arrays.asList(
								"000" ,
								"001" ,
								"002" ,
								"010" ,
								"011" ,
								"012" ,
								"020" ,
								"021" ,
								"022" ,
								"100" ,
								"101" ,
								"102" ,
								"110" ,
								"111" ,
								"112" ,
								"120" ,
								"121" ,
								"122" ,
								"200" ,
								"201" ,
								"202" ,
								"210" ,
								"211" ,
								"212" ,
								"220" ,
								"221" ,
								"222" ) ) ,
				actual );
	}

	/**
	 * Test method for {@link FinalYieldFor3}.
	 */
	@Test
	@SuppressWarnings("boxing")
	public final void testDigitsLetterDigits()
	{
		final NestedYieldFor1<Integer, String> yieldFor =
				new NestedYieldFor1<Integer, String>()
				{
					@Override
					protected Integer initialValue()
					{
						return 0;
					}

					@Override
					protected boolean is(
							final Integer currentLoopValueLevel1 )
					{
						return currentLoopValueLevel1 < 3;
					}

					@Override
					protected Integer skip(
							final Integer currentLoopValueLevel1 )
					{
						return currentLoopValueLevel1 + 1;
					}

					@Override
					protected NestedOrFinalYieldFor2<Integer, ?, String> subFor()
					{
						return
								new NestedYieldFor2<Integer, String, String>()
								{
									@Override
									protected String initialValue()
									{
										return "A";
									}

									@Override
									protected boolean is(
											final String currentLoopValueLevel2 )
									{
										return currentLoopValueLevel2.compareTo( "D" ) < 0;
									}

									@Override
									protected String skip(
											final String currentLoopValueLevel2 )
									{
										return String.valueOf(
												(char) ( currentLoopValueLevel2.charAt( 0 ) + 1 ) );
									}

									@Override
									protected NestedOrFinalYieldFor3<Integer, String, ?, String> subFor()
									{
										return
												new FinalYieldFor3<Integer, String, Integer, String>()
												{
													@Override
													protected Integer initialValue()
													{
														return 0;
													}

													@Override
													protected boolean is(
															final Integer currentLoopValueLevel2 )
													{
														return currentLoopValueLevel2 < 3;
													}

													@Override
													protected Integer skip(
															final Integer currentLoopValueLevel2 )
													{
														return currentLoopValueLevel2 + 1;
													}

													@Override
													protected String yieldReturn(
															final Integer currentLoopValueLevel1 ,
															final String  currentLoopValueLevel2 ,
															final Integer currentLoopValueLevel3 )
													{
														return
																currentLoopValueLevel1 + 
																"" + 
																currentLoopValueLevel2 + 
																"" + 
																currentLoopValueLevel3;
													}
												};
									}
								};
					}
				};

		final ArrayList<String> actual = new ArrayList<String>();
		
		while ( yieldFor.hasNext() )
		{
			final String value = yieldFor.next();
			
			actual.add( value );
			
			System.out.println( value );
		}
		
		Assert.assertEquals(
				//expected
				new ArrayList<String>(
						Arrays.asList(
								"0A0" ,
								"0A1" ,
								"0A2" ,
								"0B0" ,
								"0B1" ,
								"0B2" ,
								"0C0" ,
								"0C1" ,
								"0C2" ,
								"1A0" ,
								"1A1" ,
								"1A2" ,
								"1B0" ,
								"1B1" ,
								"1B2" ,
								"1C0" ,
								"1C1" ,
								"1C2" ,
								"2A0" ,
								"2A1" ,
								"2A2" ,
								"2B0" ,
								"2B1" ,
								"2B2" ,
								"2C0" ,
								"2C1" ,
								"2C2" ) ) ,
				actual );
	}

}
