package util.yield_for.nested;

import java.util.ArrayList;
import java.util.Arrays;

import junit.framework.Assert;

import org.junit.Test;

import util.yield_for.nested.FinalYieldFor4;
import util.yield_for.nested.NestedOrFinalYieldFor2;
import util.yield_for.nested.NestedOrFinalYieldFor3;
import util.yield_for.nested.NestedOrFinalYieldFor4;
import util.yield_for.nested.NestedYieldFor1;
import util.yield_for.nested.NestedYieldFor2;
import util.yield_for.nested.NestedYieldFor3;

/**
 * JUnit4-Testcase fr die Klasse
 * {@link FinalYieldFor4}.
 * 
 * @author Heiner K&uuml;cker
 */
public class FinalYieldFor4Test
{
	/**
	 * Test method for {@link FinalYieldFor4}.
	 */
	@Test
	@SuppressWarnings("boxing")
	public final void testDigitsDigitsDigitsDigits()
	{
		/*
		 * Nachbildung
		 * for ( int i = 0 ; i < 3 ; i++ )
		 *     for ( int j = 0 ; j < 3 ; j++ )
		 *         for ( int k = 0 ; k < 3 ; k++ )
		 *             for ( int l = 0 ; l < 3 ; l++ )
		 *                  yield return ( i + "" + j + "" + k + "" + l );
		 */
		final NestedYieldFor1<Integer, String> yieldFor =
				new NestedYieldFor1<Integer, String>()
				{
					@Override
					protected Integer initialValue()
					{
						return 0;
					}

					@Override
					protected boolean is(
							final Integer currentLoopValueLevel1 )
					{
						return currentLoopValueLevel1 < 3;
					}

					@Override
					protected Integer skip(
							final Integer currentLoopValueLevel1 )
					{
						return currentLoopValueLevel1 + 1;
					}

					@Override
					protected NestedOrFinalYieldFor2<Integer, ?, String> subFor()
					{
						return
								new NestedYieldFor2<Integer, Integer, String>()
								{
									@Override
									protected Integer initialValue()
									{
										return 0;
									}

									@Override
									protected boolean is(
											final Integer currentLoopValueLevel2 )
									{
										return currentLoopValueLevel2 < 3;
									}

									@Override
									protected Integer skip(
											final Integer currentLoopValueLevel2 )
									{
										return currentLoopValueLevel2 + 1;
									}

									@Override
									protected NestedOrFinalYieldFor3<Integer, Integer, ?, String> subFor()
									{
										return
												new NestedYieldFor3<Integer, Integer, Integer, String>()
												{
													@Override
													protected Integer initialValue()
													{
														return 0;
													}

													@Override
													protected boolean is(
															final Integer currentLoopValueLevel2 )
													{
														return currentLoopValueLevel2 < 3;
													}

													@Override
													protected Integer skip(
															final Integer currentLoopValueLevel2 )
													{
														return currentLoopValueLevel2 + 1;
													}

													@Override
													protected NestedOrFinalYieldFor4<Integer, Integer, Integer, ?, String> subFor()
													{
														return
																new FinalYieldFor4<Integer, Integer, Integer, Integer, String>()
																{
																	@Override
																	protected Integer initialValue()
																	{
																		return 0;
																	}

																	@Override
																	protected boolean is(
																			final Integer currentLoopValueLevel3 )
																	{
																		return currentLoopValueLevel3 < 3;
																	}

																	@Override
																	protected Integer skip(
																			final Integer currentLoopValueLevel3 )
																	{
																		return currentLoopValueLevel3 + 1;
																	}

																	@Override
																	protected String yieldReturn(
																			final Integer currentLoopValueLevel1 ,
																			final Integer currentLoopValueLevel2 ,
																			final Integer currentLoopValueLevel3 ,
																			final Integer currentLoopValueLevel4 )
																	{
																		return
																				currentLoopValueLevel1 + 
																				"" + 
																				currentLoopValueLevel2 + 
																				"" + 
																				currentLoopValueLevel3 +
																				"" +
																				currentLoopValueLevel4;
																	}
																};
													}
												};
									}
								};
					}
				};

		final ArrayList<String> actual = new ArrayList<String>();

		while ( yieldFor.hasNext() )
		{
			final String value = yieldFor.next();

			actual.add( value );

			System.out.println( value );
		}

		Assert.assertEquals(
				//expected
				new ArrayList<String>(
						Arrays.asList(
								"0000" ,
								"0001" ,
								"0002" ,
								"0010" ,
								"0011" ,
								"0012" ,
								"0020" ,
								"0021" ,
								"0022" ,
								"0100" ,
								"0101" ,
								"0102" ,
								"0110" ,
								"0111" ,
								"0112" ,
								"0120" ,
								"0121" ,
								"0122" ,
								"0200" ,
								"0201" ,
								"0202" ,
								"0210" ,
								"0211" ,
								"0212" ,
								"0220" ,
								"0221" ,
								"0222" ,

								"1000" ,
								"1001" ,
								"1002" ,
								"1010" ,
								"1011" ,
								"1012" ,
								"1020" ,
								"1021" ,
								"1022" ,
								"1100" ,
								"1101" ,
								"1102" ,
								"1110" ,
								"1111" ,
								"1112" ,
								"1120" ,
								"1121" ,
								"1122" ,
								"1200" ,
								"1201" ,
								"1202" ,
								"1210" ,
								"1211" ,
								"1212" ,
								"1220" ,
								"1221" ,
								"1222" ,

								"2000" ,
								"2001" ,
								"2002" ,
								"2010" ,
								"2011" ,
								"2012" ,
								"2020" ,
								"2021" ,
								"2022" ,
								"2100" ,
								"2101" ,
								"2102" ,
								"2110" ,
								"2111" ,
								"2112" ,
								"2120" ,
								"2121" ,
								"2122" ,
								"2200" ,
								"2201" ,
								"2202" ,
								"2210" ,
								"2211" ,
								"2212" ,
								"2220" ,
								"2221" ,
								"2222" ) ) ,
				actual );
	}

	/**
	 * Test method for {@link FinalYieldFor4}.
	 */
	@Test
	@SuppressWarnings("boxing")
	public final void testDigitsLetterDigitsLetter()
	{
		final NestedYieldFor1<Integer, String> yieldFor =
				new NestedYieldFor1<Integer, String>()
				{
					@Override
					protected Integer initialValue()
					{
						return 0;
					}

					@Override
					protected boolean is(
							final Integer currentLoopValueLevel1 )
					{
						return currentLoopValueLevel1 < 3;
					}

					@Override
					protected Integer skip(
							final Integer currentLoopValueLevel1 )
					{
						return currentLoopValueLevel1 + 1;
					}

					@Override
					protected NestedOrFinalYieldFor2<Integer, ?, String> subFor()
					{
						return
								new NestedYieldFor2<Integer, String, String>()
								{
									@Override
									protected String initialValue()
									{
										return "A";
									}

									@Override
									protected boolean is(
											final String currentLoopValueLevel2 )
									{
										return currentLoopValueLevel2.compareTo( "D" ) < 0;
									}

									@Override
									protected String skip(
											final String currentLoopValueLevel2 )
									{
										return String.valueOf(
												(char) ( currentLoopValueLevel2.charAt( 0 ) + 1 ) );
									}

									@Override
									protected NestedOrFinalYieldFor3<Integer, String, ?, String> subFor()
									{
										return
												new NestedYieldFor3<Integer, String, Integer, String>()
												{
													@Override
													protected Integer initialValue()
													{
														return 0;
													}

													@Override
													protected boolean is(
															final Integer currentLoopValueLevel2 )
													{
														return currentLoopValueLevel2 < 3;
													}

													@Override
													protected Integer skip(
															final Integer currentLoopValueLevel2 )
													{
														return currentLoopValueLevel2 + 1;
													}


													@Override
													protected NestedOrFinalYieldFor4<Integer, String, Integer, ?, String> subFor()
													{
														return
																new FinalYieldFor4<Integer, String, Integer, String, String>()
																{
																	@Override
																	protected String initialValue()
																	{
																		return "a";
																	}
		
																	@Override
																	protected boolean is(
																			final String currentLoopValueLevel2 )
																	{
																		return currentLoopValueLevel2.compareTo( "d" ) < 0;
																	}
		
																	@Override
																	protected String skip(
																			final String currentLoopValueLevel2 )
																	{
																		return String.valueOf(
																				(char) ( currentLoopValueLevel2.charAt( 0 ) + 1 ) );
																	}

																	@Override
																	protected String yieldReturn(
																			final Integer currentLoopValueLevel1 ,
																			final String  currentLoopValueLevel2 ,
																			final Integer currentLoopValueLevel3 ,
																			final String  currentLoopValueLevel4 )
																	{
																		return
																				currentLoopValueLevel1 + 
																				"" + 
																				currentLoopValueLevel2 + 
																				"" + 
																				currentLoopValueLevel3 +
																				"" +
																				currentLoopValueLevel4;
																	}
																};
													}
												};
									}
								};
					}
				};

		final ArrayList<String> actual = new ArrayList<String>();
		
		while ( yieldFor.hasNext() )
		{
			final String value = yieldFor.next();
			
			actual.add( value );
			
			System.out.println( value );
		}
		
		final ArrayList<String> expected =
				new ArrayList<String>(
						Arrays.asList(
								"0A0a" ,
								"0A0b" ,
								"0A0c" ,
								"0A1a" ,
								"0A1b" ,
								"0A1c" ,
								"0A2a" ,
								"0A2b" ,
								"0A2c" ,
								"0B0a" ,
								"0B0b" ,
								"0B0c" ,
								"0B1a" ,
								"0B1b" ,
								"0B1c" ,
								"0B2a" ,
								"0B2b" ,
								"0B2c" ,
								"0C0a" ,
								"0C0b" ,
								"0C0c" ,
								"0C1a" ,
								"0C1b" ,
								"0C1c" ,
								"0C2a" ,
								"0C2b" ,
								"0C2c" ,
								"1A0a" ,
								"1A0b" ,
								"1A0c" ,
								"1A1a" ,
								"1A1b" ,
								"1A1c" ,
								"1A2a" ,
								"1A2b" ,
								"1A2c" ,
								"1B0a" ,
								"1B0b" ,
								"1B0c" ,
								"1B1a" ,
								"1B1b" ,
								"1B1c" ,
								"1B2a" ,
								"1B2b" ,
								"1B2c" ,
								"1C0a" ,
								"1C0b" ,
								"1C0c" ,
								"1C1a" ,
								"1C1b" ,
								"1C1c" ,
								"1C2a" ,
								"1C2b" ,
								"1C2c" ,
								"2A0a" ,
								"2A0b" ,
								"2A0c" ,
								"2A1a" ,
								"2A1b" ,
								"2A1c" ,
								"2A2a" ,
								"2A2b" ,
								"2A2c" ,
								"2B0a" ,
								"2B0b" ,
								"2B0c" ,
								"2B1a" ,
								"2B1b" ,
								"2B1c" ,
								"2B2a" ,
								"2B2b" ,
								"2B2c" ,
								"2C0a" ,
								"2C0b" ,
								"2C0c" ,
								"2C1a" ,
								"2C1b" ,
								"2C1c" ,
								"2C2a" , 
								"2C2b" , 
								"2C2c" ) );

		for ( int i = 0 ; i < Math.max( expected.size() , actual.size() ) ; i++)
		{
			final String expectedElem = expected.get( i );
			final String   actualElem =   actual.get( i );

			System.out.println( i + " " + expectedElem + " " + actualElem );
			
			Assert.assertEquals(
					expectedElem ,
					actualElem );
		}

		Assert.assertEquals(
				expected ,
				actual );
	}

}
